<!---
/* *************************************************************** 
Author: 	
	PaperThin, Inc.
	G. Cronkright
Name:
	$department_detail_program_listing_rh.cfm
Elements:
	Program (via render mode)
	Department (via getCEData)
Summary:
	Renders the a pragram listing from the program element
	for a specified department.
	Also renders department details.
ADF App:
	PT Course Catalog
History:
	2013-03-13 - GAC - Created
*/
--->
<cfif StructKeyExists(request.page.metadata,"CourseCatalog")>
<cfscript>
	// Do Not Cache if using pagination
	request.element.isStatic = 0;
	
	// Get the Department Data from CS
	items = attributes.elementinfo.elementdata.PropertyValues;
	
	item = StructNew();
	if ( ArrayLen(items) )
		item = items[1];
	
	progItems=ArrayNew(1);
	
	if ( StructKeyExists(request.page.metadata.CourseCatalog,"deptID") AND LEN(TRIM(request.page.metadata.CourseCatalog.deptID)) ) 
		deptID = request.page.metadata.CourseCatalog.deptID;
	
	if ( LEN(TRIM(deptID)) )
		progItems = application.ptCourseCatalog.programDAO.getProgramsByDeptID(deptID=deptID); 

//Display Page/Data Binding Metadata
//application.ptCourseCatalog.utils.doDump(request.page.metadata,"request.page.metadata",0);
//Display Department Element Data	
//application.ptCourseCatalog.utils.doDump(items,"items",0);
//Display School Element Data	
//application.ptCourseCatalog.utils.doDump(progItems,"progItems",0);

	totalItems = ArrayLen(progItems);
	columnCount = 3;
	
	// Calculate the number of items per Dept column
	itemsPerColumn = CEILING(totalItems / columnCount);
	itemsRemainder = (totalItems MOD itemsPerColumn);
	startItem = 1;
	endItem = itemsPerColumn;
	
	csPageID = 0;
	csPageURL = "";
</cfscript>	
	
<cfoutput>
<div id="ccDeptDetailWrapper">
	<cfif totalItems> 
	<div id="ccDeptProgramWrapper">
		<cfloop from="1" to="#columnCount#" index="col">
		
		<cfif startItem LTE endItem>
		<!--- New Column #col# --->
		<ul id="ccDeptProgram-#col#" class="ccDeptProgramCol">
			<cfloop from="#startItem#" to="#endItem#" index="itm">
			<cfset csPageURL = "">
			<li>
			<cfif IsNumeric(progItems[itm].values.catalogPageID)>	
				<cfset csPageID = progItems[itm].values.catalogPageID>
				<cfset csPageURL = application.ptCourseCatalog.csData.getCSPageURL(pageID=csPageID)>
			</cfif> 
			<cfif LEN(TRIM(csPageURL))>
			<a href="#csPageURL#">#progItems[itm].values.progName#</a>
			<cfelse>
			#progItems[itm].values.progName#
			</cfif>
			</li>	
			</cfloop>
		</ul>
		</cfif> 
		
		<!--- // Set the Start and End of the next Column --->
		<cfset startItem = itm>
		<cfset endItem = (itm + itemsPerColumn) - 1>
		<cfif endItem GT totalItems>
			<cfset endItem = (itm + itemsRemainder) - 1>
		</cfif>
		
		</cfloop>
		<div class="ccClear"></div>
	</div>
	</cfif>
	
	<cfif NOT StructIsEmpty(item)>
	<div id="ccSchoolDetailDescription">
		<!--- <cfdump var="#item#"> --->
		#item.values.description#
	</div>
	</cfif>
</div>	
</cfoutput>
<cfelse>
<!--- // TODO: Display an Error message if a School has not been selected --->
</cfif>